# Interface BIOCallback

@Deprecated public interface BIOCallback
Deprecated.
Unused. Will be removed in Tomcat 9.1 an has been removed in Tomcat 10.1.
Open SSL BIO Callback Interface

Author:
  Mladen Turk

## Method Summary

Modifier and Type
Method
Description
`String`
`gets(int len)`
Deprecated.
Read string up to the len or CLRLF
`int`
`puts(String data)`
Deprecated.
Puts string
`int`
`read(byte[] buf)`
Deprecated.
Read data
`int`
`write(byte[] buf)`
Deprecated.
Write data

## Method Details

### write

int write(byte[] buf)
Deprecated.
Write data

Parameters:
  `buf` - containing the bytes to write.
Returns:
  Number of characters written.

### read

int read(byte[] buf)
Deprecated.
Read data

Parameters:
  `buf` - buffer to store the read bytes.
Returns:
  number of bytes read.

### puts

int puts(String data)
Deprecated.
Puts string

Parameters:
  `data` - String to write
Returns:
  Number of characters written

### gets

String gets(int len)
Deprecated.
Read string up to the len or CLRLF

Parameters:
  `len` - Maximum number of characters to read
Returns:
  String with up to len bytes read